--
-- fergforklift
--
-- Author  henly20
-- Date  31.05.2009


fergforklift = {};

function fergforklift.prerequisitesPresent(specializations)
	Vehicle.registerJointType("frontloader");
	Vehicle.registerJointType("trailerLow");
	   return true;
end;

function fergforklift:load(xmlFile)

	local rotationPartNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPart1#index"));
		if rotationPartNode1 ~= nil then
        self.rotationPart1 = {};
        self.rotationPart1.node = rotationPartNode1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart1#minRot"));
        self.rotationPart1.minRot = {};
        self.rotationPart1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart1#maxRot"));
        self.rotationPart1.maxRot = {};
        self.rotationPart1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart1#rotTime"), 2)*1000;
        self.rotationPart1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart1#touchRotLimit"), 10));
    end;
	local rotationPartNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPart2#index"));
		if rotationPartNode2 ~= nil then
        self.rotationPart2 = {};
        self.rotationPart2.node = rotationPartNode2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart2#minRot"));
        self.rotationPart2.minRot = {};
        self.rotationPart2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart2#maxRot"));
        self.rotationPart2.maxRot = {};
        self.rotationPart2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart2#rotTime"), 2)*1000;
        self.rotationPart2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart2#touchRotLimit"), 10));
    end;	
		
		local translationPartNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.translationPart2#index"));
		if translationPartNode2 ~= nil then
        self.translationPart2 = {};
        self.translationPart2.node = translationPartNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#minTrans"));
        self.translationPart2.minTrans = {};
        self.translationPart2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#maxTrans"));
        self.translationPart2.maxTrans = {};
        self.translationPart2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.maxTrans[3] = Utils.getNoNil(z, 0);
		self.translationPart2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#transTime"), 2)*1000;
        self.translationPart2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#touchTransLimit"), 10);
    end;
	  local translationPartNode3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.translationPart3#index"));
		if translationPartNode3 ~= nil then
        self.translationPart3 = {};
        self.translationPart3.node = translationPartNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart3#minTrans"));
        self.translationPart3.minTrans = {};
        self.translationPart3.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart3.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart3.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart3#maxTrans"));
        self.translationPart3.maxTrans = {};
        self.translationPart3.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart3.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart3.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart3.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart3#transTime"), 2)*1000;
        self.translationPart3.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart3#touchTransLimit"), 10);
    end;
	local translationPartNode4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.translationPart4#index"));
		if translationPartNode4 ~= nil then
        self.translationPart4 = {};
        self.translationPart4.node = translationPartNode4;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart4#minTrans"));
        self.translationPart4.minTrans = {};
        self.translationPart4.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart4.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart4.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart4#maxTrans"));
        self.translationPart4.maxTrans = {};
        self.translationPart4.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart4.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart4.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart4.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart4#transTime"), 2)*1000;
        self.translationPart4.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart4#touchTransLimit"), 10);
    end;
	
	hydraulicUpSoundFile = Utils.getFilename("hydraulicUp.wav", self.baseDirectory);
    self.hydraulicUpSoundId = createSample("HYDRAULICUP_hydraulicUp");
    loadSample(self.hydraulicUpSoundId, hydraulicUpSoundFile, false);
    self.hydraulicUpPlaying = false;
	
	hydraulicDownSoundFile = Utils.getFilename("hydraulicDown.wav", self.baseDirectory);
    self.hydraulicDownSoundId = createSample("HYDRAULICDOWN_hydraulicDown");
    loadSample(self.hydraulicDownSoundId, hydraulicDownSoundFile, false);
    self.hydraulicDownPlaying = false;
	

	self.controlpath = Utils.getFilename("FGHelp.png", self.baseDirectory);
    self.hudFGHelpPoxX = 0.0154;
    self.hudFGHelpPoxY = 1-0.4715;
    self.hudFGHelpWidth = 0.260;
    self.hudFGHelpHeight = 0.220;
    self.hudFGHelpOverlay = Overlay:new("hudFGHelp", self.controlpath, self.hudFGHelpPoxX, self.hudFGHelpPoxY, self.hudFGHelpWidth, self.hudFGHelpHeight);
     self.bcActive = false;

	
end;

function fergforklift:delete()

	
end;

function fergforklift:mouseEvent(posX, posY, isDown, isUp, button)
end;

function fergforklift:keyEvent(unicode, sym, modifier, isDown)


	if sym == Input.KEY_7 then
	
		self.rotationMax1 = isDown;
		self.rotationMax2 = isDown;
		self.translationMax2 = isDown;
	end;
		
	if sym == Input.KEY_8 then

	self.rotationMin1 = isDown;
	self.rotationMin2 = isDown;
	self.translationMin2 = isDown;
	end;
	
		if sym == Input.KEY_6 then

		self.translationMax3 = isDown;
		self.translationMax4 = isDown;
	end;
	if sym == Input.KEY_5 then
	
		self.translationMin3 = isDown;
		self.translationMin4 = isDown;
	end;
	
	if isDown and sym == 48 then -- Key: 0
		self.bcActive = not self.bcActive;
	end;
end;

function fergforklift:update(dt)

 
		if self.rotationPart1.node ~= nil and (self.rotationMax1 or self.rotationMin1) then
			local x, y, z = getRotation(self.rotationPart1.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart1.maxRot, self.rotationPart1.minRot, 3, self.rotationPart1.rotTime*2, dt, not self.rotationMax1);
		setRotation(self.rotationPart1.node, unpack(newRot));
			
			if not self.hydraulicDownPlaying then
				playSample(self.hydraulicDownSoundId, 0, 1, 0);
				self.hydraulicDownPlaying = true;
			end;
		else
			if self.hydraulicDownPlaying then
				stopSample(self.hydraulicDownSoundId);
				self.hydraulicDownPlaying = false;
			end; 
		end;

		if self.rotationPart2.node ~= nil and (self.rotationMax2 or self.rotationMin2) then
			local x, y, z = getRotation(self.rotationPart2.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart2.maxRot, self.rotationPart2.minRot, 3, self.rotationPart2.rotTime*2, dt, not self.rotationMax2);
			setRotation(self.rotationPart2.node, unpack(newRot));
		end;
		if self.translationPart2.node ~= nil and (self.translationMax2 or self.translationMin2) then
			local x, y, z = getTranslation(self.translationPart2.node);
			local trans = {x,y,z};
			local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart2.maxTrans, self.translationPart2.minTrans, 3, self.translationPart2.transTime*2, dt, not self.translationMax2);
			setTranslation(self.translationPart2.node, unpack(newTrans));
		end;
		if self.translationPart3.node ~= nil and (self.translationMax3 or self.translationMin3) then
			local x, y, z = getTranslation(self.translationPart3.node);
			local trans = {x,y,z};
			local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart3.maxTrans, self.translationPart3.minTrans, 3, self.translationPart3.transTime*2, dt, not self.translationMax3);
			setTranslation(self.translationPart3.node, unpack(newTrans));
		end;
		if self.translationPart4.node ~= nil and (self.translationMax4 or self.translationMin4) then
			local x, y, z = getTranslation(self.translationPart4.node);
			local trans = {x,y,z};
			local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart4.maxTrans, self.translationPart4.minTrans, 3, self.translationPart4.transTime*2, dt, not self.translationMax4);
			setTranslation(self.translationPart4.node, unpack(newTrans));
		if not self.hydraulicUpPlaying then
				playSample(self.hydraulicUpSoundId, 0, 1, 0);
				self.hydraulicUpPlaying = true;
			end;
		else
			if self.hydraulicUpPlaying then
				stopSample(self.hydraulicUpSoundId);
				self.hydraulicUpPlaying = false;
			end; 
		end;
	
		

end;

function fergforklift:draw()

	 if self.hudFGHelpOverlay ~= nil then
		if self.bcActive then
		self.hudFGHelpOverlay:render();
		end;
	end;
		if self.bcActive then	
			g_currentMission:addExtraPrintText("Key 0: Menu Off");
		else
			g_currentMission:addExtraPrintText("Key 0: Menu On");
		end;

end;

function fergforklift:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;